// code-analyzer creates graph from a C source code.
// Copyright © 2021 Volodymyr Patuta
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "cparse.h"
#include "matcom.h"
#include "vec.h"
#include <stdio.h>
#include <string.h>

int main(int argc, char *argv[])
{
	(void)argc;
	(void)argv;
	graph_vec gv = vnew_graph();
	graph_mco gmc = mcgragh();
	// find_funcs("/home/user/files/dot_files/st/x.c", &gv, &gmc);
	find_funcs("test.c", &gv, &gmc);
	// findAndParse("/home/user/files/dot_files/st/", &gv, &gmc);
	// for (int i = 0; i <= gmc.nba; ++i) {
	// 	printf("%d.%s -> %d.%s\n", gmc.vec[i].i, gmc.func[gmc.vec[i].i], gmc.vec[i].j, gmc.func[gmc.vec[i].j]);
	// }
	// puts("\n");
	vprint(gv.node[8], &gv);
	mcprint(gmc, 8);

	vfind_cycles(&gv);
	mcfind_cycles(&gmc);

	vdot_graph(gv, true);
	mcdot_graph(gmc, true);

	mcdelete_graph(&gmc);
	vdelete_graph(&gv);

	return 0;
}
